from appfolder import appFlask
from flask import render_template, redirect
import datetime
timenow = datetime.datetime.now().strftime("%Y-%m-%d %H:%M")
import threading

import time
import RPi.GPIO as GPIO
GPIO.setmode(GPIO.BCM)
GPIO.setup(17 , GPIO.IN, pull_up_down=GPIO.PUD_UP)

speed = 0
overall = 0
max = 0
count = 0
c = 0
on = 0
# Tell GPIO library to use GPIO references
now = time.time()
end = time.time()
new = time.time()
dic = {"current_speed":speed, "overall_speed":overall, "best_speed":max, "total_access":count}
start = time.time()
def sensorCallback(channel):
  # Called if sensor output changes
  global speed, overall, max, count, c, start, now, end, new, on
  print(speed, overall, max, count, c)
  if on:
      if not GPIO.input(channel):
        count += 1
        c+=1
      if c == 0:
        now = time.time()
      if c == 5:
        c = 0
        new = time.time()
        speed = 5 / (new-now)
        if speed > max:
            max = speed
      if GPIO.input(channel):
        end = time.time()
        overall = count/(end - start)
      dic['current_speed'] = speed
      dic['overall_speed'] = overall
      dic['best_speed'] = max
      dic['total_access'] = count

def take():
    global count,on
      # Loop until users quits with CTRL-C
    try:
    # Loop until users quits with CTRL-C
        while True :
            time.sleep(0.1)

    except KeyboardInterrupt:
    # Reset GPIO settings
        GPIO.cleanup()


t = threading.Thread(target=take,args=())
t.daemon = True
@appFlask.route('/')
def welcome():
    return redirect('/index')
first = 0
taking = 0
from appfolder.forms import CameraForm

@appFlask.route('/index', methods=['GET', 'POST'])
def states():
    global t,first,taking,on,dic
    form = CameraForm()
    print dic

    if form.is_submitted():

        if (form.start.data):
            print('form')
            taking = on
            on = 1
            if not first:
                first = 1
                t.start()

            if not taking and on:
                print('if')


        elif (form.pause.data):
            on = 0

        return render_template('index.html', title='Current Status',form = form, **dic)
    return render_template('index.html', title='Current Status',form = form, **dic)
# Above this line is a sample use of a template without a form.
GPIO.add_event_detect(17, GPIO.BOTH, callback=sensorCallback, bouncetime=200)

from flask_restful import Resource, Api, reqparse, abort
api = Api(appFlask)

parser = reqparse.RequestParser()
parser.add_argument('name')

class FullList(Resource):
    def get(self):
        return user

    def post(self):

        return

api.add_resource(FullList, '/devices')
